<?php
/**
* @version	$Id: category_items_dbitem.php 14870 2011-12-16 11:54:01Z alex $
* @package	In-Portal
* @copyright	Copyright (C) 1997 - 2009 Intechnic. All rights reserved.
* @license      GNU/GPL
* In-Portal is Open Source software.
* This means that this software may have been modified pursuant
* the GNU General Public License, and as distributed it includes
* or is derivative of works licensed under the GNU General Public License
* or other free or open source software licenses.
* See http://www.in-portal.org/license for copyright notices and details.
*/

defined('FULL_PATH') or die('restricted access!');

class CategoryItems_DBItem extends kDBItem {

	/**
	 * Returns part of SQL WHERE clause identifying the record, ex. id = 25
	 *
	 * @param string $method Child class may want to know who called GetKeyClause, Load(), Update(), Delete() send its names as method
	 * @param Array $keys_hash alternative, then item id, keys hash to load item by
	 * @see kDBItem::Load()
	 * @see kDBItem::Update()
	 * @see kDBItem::Delete()
	 * @return string
	 * @access protected
	 */
	protected function GetKeyClause($method = null, $keys_hash = null)
	{
		$table_info = $this->getLinkedInfo();

		return '(CategoryId=' . $this->GetID() . ' AND ' . $table_info['ForeignKey'] . '=' . $table_info['ParentId'] . ')';
	}

	/**
	 * Generate and set new temporary id
	 *
	 * @return void
	 * @access public
	 */
	public function setTempID()
	{
		// don't set temp id for this item
	}
}